/* c_sock1.c - client for tcp-socket */
#include "inet.h"
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include        <sys/types.h>
#include        <sys/time.h>


/* read from 0, write to socket, read from socket, write to 1 */
void talk(int sockfd)
{  int n,i;
   char sendline[MAXLINE];
   fd_set readset;

   write(1,"c> ",3);
   while (1) {
     /* tv.tv_sec = tv.tv_usec = 1;*/
     FD_ZERO(&readset);
     FD_SET(sockfd,&readset);
     FD_SET(0,&readset);
     if ( (i = select(sockfd+1,&readset,NULL,NULL,NULL)) > 0 ) {
        if (FD_ISSET(0,&readset)){
          if ((n = read(0,sendline, MAXLINE))<=0) break;
          write(sockfd, sendline, n);
          write(1,"c> ",3);
        }
        if (FD_ISSET(sockfd,&readset)){
             if ((n=read(sockfd,sendline,MAXLINE))<=0) break;
             write(1,"\n",1);
             write(1,sendline,n);
	     write(1,"C> ",3);
        }
     }
   }
   write(1,"\n",1);
}
int main(int argc,char *argv[])
{  int sockfd;
   struct sockaddr_in serv_addr;
   struct hostent *hp;
   if (argc != 2) {
           fprintf(stderr,"use: %s <hostname>\n",argv[0]); exit(1);
   }
   hp = gethostbyname(argv[1]);
   if ( hp == NULL ) {
     printf("no host-information for %s\n",argv[1]); exit (3);
   }
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(SERV_TCP_PORT);
   (void) memcpy(&serv_addr.sin_addr.s_addr, *hp->h_addr_list,
                      sizeof (serv_addr.sin_addr.s_addr));
   if ((sockfd = socket(AF_INET,SOCK_STREAM,0)) < 0) {
      fprintf(stderr,"c_sock: can't open socket\n"); exit(-1);
   }
   if (connect(sockfd, (struct sockaddr *) &serv_addr,
            sizeof(serv_addr)) < 0)  {
     fprintf(stderr,"c_sock: no connection to server\n"); exit(-2);
   }
   talk(sockfd);
   exit(0);
}
