#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "error.h"

#define LCK F_SETLKW
/*
    #define LCK F_SETLK
*/

int main(int argc,char *argv[])
{
  int fkt; int fd;
  /* File zum Lesen und Schreiben eroeffnen 
   Operationen: w   schreiben
                r   lesen
  */
  struct flock lockr;

  if ( argc !=3 ) {
      fprintf(stderr,"use: %s [r|w] <filename>\n",argv[0]);
      exit(1);
  }
  if ( ! strcmp(argv[1],"r") )
     fkt=F_RDLCK;
  else 
     if ( ! strcmp(argv[1],"w")) fkt=F_WRLCK;
     else { fprintf(stderr,"use: %s [r|w] <filename>\n",argv[0]);
            exit(2);
     }
  
  if ((fd=open(argv[2],O_RDWR))<0) {
      err_sys("open-error ");
  }
  lockr.l_type=fkt;
  lockr.l_whence = SEEK_CUR;
  lockr.l_start=0;
  lockr.l_len=100;
  printf("\n\n%d: %s-fcntl fuer '%s'\n",getpid(),argv[1],argv[2]);
  if ( fcntl(fd,LCK,&lockr) < 0 ) {
     err_sys("%d: fcntl nicht moeglich",getpid());
  }
  printf("%d: fcntl erfolgreich, jetzt Zugriff\n",getpid());
  pause();
  exit(0);
}
